#!/usr/local/python/2.4.2/bin/python
#Rene Warren April 11th/2006


import sys
import os
import commands
import time
import datetime

#sys.path.append('/home/rwarren/python/standard/CherryPy-2.2.0')
#sys.path.append('/home/rwarren/python/standard/CherryPy-2.2.0/cherrypy/lib')

import cherrypy
#import autoreload
import re


EXAMPLE_FILE = "/var/htsi/THOR_web/example.fasta"
THOR_WRAPPER = "/var/htsi/THOR_web/launchTHORoscar.py"

REQUEST_DIR     = "/projects/02/rwarren/tmp/THOR/requests/"
OUTPUT_DIR_ROOT = "/projects/02/rwarren/tmp/THOR/runs/"

TRACE_ARCHIVE   = "/home/pubseq/databases/trace_archive/"
ANIMAL_FILE     = "/home/pubseq/databases/trace_archive/ANIMAL.HAVE"


TRACE_ARCHIVE_FTP = "/ftp.ensembl.org/pub/traces/"





#====================
##The application
class WelcomePage:


    #---------------------------------------------
    def index(self, email = '', sequence = ''):
        # Ask for the user's name.



        ######## Get list of animal and directories where reads are
        animal_list=WelcomePage.readFile(self)
        underscore_regex = re.compile('_')              ### underscore
        
     
        ######## Load Default example sequence in
        if sequence == '':
           file_obj = open(EXAMPLE_FILE, 'r')

           ### below is to accomodate various browsers running in different environment
           for line in file_obj:
              linelength = int(len(line))
              #print "--%i--" % linelength
              if linelength > 70:
                 bases = list(line)         
                 cntbase = 0                      
                 for base in bases:
                    cntbase += 1 
                    sequence += base
                    if cntbase > 70:
                       sequence += "\n";
                       cntbase = 0
              else:
                 sequence += line



           file_obj.close()

        yield """<html>
<head>
    <title>THOR</title>
</head>

<body background="http://www.bcgsc.ca/people/rwarren/htdocs/THOR/thor_mosaic_light.jpg" vlink="#414018" alink="#523127" link="#6e3529">

        <style type="text/css">

        body {
            font: 80% "Lucida Grande", Verdana, Lucida, Helvetica, Arial, sans-serif;
            color: Black;
            margin: 2em;
            padding: 0em;
        }

        h1 {
        	font-size: 350%;
        	color: #414018;
        	margin-bottom: 0em;
        }

        h2 {
        	font-size: 180%;
                color: #523127;
        	margin: 0em;
        	padding: 0.5em;
        }


	h3 {

		font-size: 120%;
                color: #414018;
                margin: 0em;
                padding: 0.5em;
	}

        h4 {
                font-size: 90%;
                color: #76797c;
                margin: 0 0 0.2em 0;

        }


	A {
		text-decoration:none
	}




        #content {
        	padding: 1em;
        }

        fieldset {
            border: 1px solid #414018;
            margin: 1em 0em 1em 0em;
            padding: 0em 1em 1em 1em;
            line-height: 1.5em;
            width: auto;
        	background: #F6F6E1;
        }

        legend {
        	border: 1px solid #414018;
            background: White;
            padding: 0.5em;
            font-size: 90%;
        }

        textarea {
            font: 100% Monaco, "Courier New", Courier, monospace;
            border: 1px solid #414018;
            color: Black;
            background: White;
            width: 100%;
        }

        input {
            font-family: "Lucida Grande", Verdana, Lucida, Helvetica, Arial, sans-serif;
            visibility: visible;
            border: 1px solid #414018;
            color: Black;
            vertical-align: middle;
            background: White;
        }

        select {
            border: 1px solid #414018;
            color: Black;
            background-color: White;
            vertical-align: top;
        }

        /* The edit form elements */

        .field {
            top: 0;
            left: 0;
            margin: 0 1em 1em 0;
        }

        .fieldRequired {
            background: url(http://web01.bcgsc.ca:9500/sites/helptest/required.gif) center left no-repeat;
            padding: 0 0 0 8px;
            color: White;
        }

        .formHelp {
            font-size: 90%;
            color: #76797c;
            margin: 0 0 0.2em 0;
        }

        .formHelp:hover {
            color: Black;
            cursor: default;
        }

        .formControls {
           margin: 1em 0;
        }

        .error {
            /* Class for error indication in forms */
            background-color: #ffce7b;
            border: 1px solid #ffa500;
            padding: 1em;
            margin: 0 0 1em 0;
            width: 95%;
        }

        .error .fieldRequired {
           color: #ffce7b;
        }

        /* End edit form elements */


        label {
        	font-weight: bold;
        	font-size: 120%;
        	color: #414018;
        	text-align: left;
        }

        </style>


<table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr><th align=right><a href="http://www.bcgsc.ca" target="blank"><img src="http://www.bcgsc.ca/people/rwarren/htdocs/THOR/gsc.gif" border=0 title="Genome Sciences Centre home page" alt="Genome Sciences Centre home page"></a></th></tr>
</table>

<table>
    <tr><th>
        <img src="http://www.bcgsc.ca/people/rwarren/htdocs/THOR/thor_best_canvas_sepia.gif" alt="Thor, the nature god of thunder in Norse Mythology" title="Thor, the nature god of thunder in Norse Mythology">
</th>
<th>
	<h1>THOR</h1>
	<h2>Targeted Human Ortholog Reconstructor</h2>
</th></tr>
</table>
        """

        yield """
     
        <div id="content">

        <form action="http://www.bcgsc.ca/services/thor/assemblyRequest" method="POST">

            <fieldset>


            <div class="field">
              <label>Sequence to assemble in another animal</label>
        	  <div class="formHelp">Sequence must be known Human DNA, 15 Kb maximum</div>

        <textarea name='sequence' value='test' ALT=">Name|description|chromosome|start coord|end coord|strand (+1/-1)" TITLE=">Name|description|chromosome|start coord|end coord|strand (+1/-1)" ROWS=18 COLS=80 WRAP='virtual'>%s</textarea>

        </div>

        <div class="field">
        <label>Email address</label>
        <div class="formHelp">The results will be sent to this address after processing</div>
        <input type="text" name="email" value="%s" size="50"/>
        </div>
        
        <div class="field">
        <label>Select a species</label>
        <div class="formHelp">Pick one!</div>
        """ % (sequence, email)

        yield "<SELECT NAME=dir>"


        species_list = animal_list.keys()
        species_list.sort()

        for species in species_list:

           animal_name = underscore_regex.sub(' ',species) ### replace underscore by space
           latin_name = underscore_regex.sub(' ',animal_list[species]['latin']) ### replace underscore by space


           yield "<OPTION value=%s>%s (%s)</OPTION>" % (animal_list[species]['all'], animal_name,latin_name)

        yield "</SELECT>"
        
        yield """
</div>

<input type="submit" value="Submit for assembly">
<p><h3><a href="http://www.bcgsc.ca/people/rwarren/htdocs/THOR/HELP.html"><u>THOR help</u></a>&nbsp;&nbsp;&nbsp;&nbsp;<a href="http://www.bcgsc.ca/bioinfo/software/thor/"><u>download THOR</u></a></h3>
<p><h4>*Running THOR can take up to 2 hours</h4>

</fieldset>
</form>

</div>
<hr color=#000000>
<p>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<td align="left"><b>Email: <a href="mailto:thor@bcgsc.ca">thor@bcgsc.ca</a></b></td>
  		<td align="right"><b>Powered by <a href="http://www.cherrypy.org" target="blank">Cherry Py</a></b></td>
	</tr>
</table>

</html>    
"""
    index.exposed = True

    #---------------------------------------------
    def assemblyRequest(self, sequence = None, email = None, dir = None):

        # CherryPy passes all GET and POST variables as method parameters.
        # It doesn't make a difference where the variables come from, how
        # large their contents are, and so on.
        #
        # You can define default parameter values as usual. In this
        # example, the "sequence" parameter defaults to None so we can check
        # if a name was actually specified.


        ######## job id for run directory

        date = str(datetime.datetime.now())
        cr_regex = re.compile('[\s+\:]')                ### regex for undesirable characters in datetime string
  

        jobid = cr_regex.sub('_',date)                 ###removes undesirable characters globally


        ########

        if (sequence and email):

            #### filter for DNA sequence (length, characters, etc)
            header = ''
            query_dna = ''
            seq_length = 0

            #### Size of the sequence
            header_regex = re.compile('^(\>\w+\|\w+\|\d+\|\d+\|\d+\|(-)?\d{1})')
            header_match = header_regex.match(sequence)

            if header_match != None:
               header = header_match.group(1)
            else:
               return 'The header of your fasta file is incorrect.<BR>Make sure is is in the proper format:<BR>>\w+|\w+|\d+|\d+|\d+|(-)?\d{1}<BR>>somename|description|chromosome|start|end|orientation. Please alter your header <a href="./">here</a>.'


            head_regex = re.compile('>.+\n')                  ### regex for the header
            cr_regex = re.compile('[\n\s+\t+]')               ### regex for any spaces
 
            seq_dna_regex = re.compile('^([ACGTN]+)$', re.I) ### looks for DNA
            directories = dir.split(':')
            (animal_name,latin_name,fasta_dir,qual_dir)=(str(directories[0]),str(directories[1]),str(directories[2]),str(directories[3]))
        

            subseq = header_regex.sub('', sequence) ###removes header globally
            subseq_nocr = cr_regex.sub('',subseq) ###removes whitespace globally


            full_dna = seq_dna_regex.match(subseq_nocr)

            if not full_dna:
               return 'Your sequence contains unknown characters, different from A,C,G,T or N.  Please alter your sequence <a href="./index?email=%s">here</a>.' % email
            else:
               query_dna = full_dna.group(1)
               seq_length = len(query_dna)
               if seq_length > 15000:
                  return 'Your sequence is too large (>15 kb).  Please alter your sequence <a href="./index?email=%s">here</a>.' % email

            #### Write Sequence to a file

            input_fasta_seq = header.upper() + "\n" + query_dna.upper() + "\n"
            input_fasta_file = REQUEST_DIR + jobid + ".fa" 
            output_dir = OUTPUT_DIR_ROOT + jobid + "/"

            file_obj = open(input_fasta_file, 'w')
            file_obj.write(input_fasta_seq)
            file_obj.close()

            #### Make directory for this run
 
            mkdircmd = "mkdir " + output_dir
            (status, out)=commands.getstatusoutput(mkdircmd)
            #print "%s %s" % (status,out)

            #### Remove underscore
            underscore_regex = re.compile('_')              ### underscore
            animal_clean = underscore_regex.sub(' ', animal_name) ### replace underscore by space
            latin_clean = underscore_regex.sub(' ',latin_name)   ### replace underscore by space

 

            #### Run Wrapper 

            cmd = THOR_WRAPPER + " " + input_fasta_file + " " +  fasta_dir + " " + qual_dir + " " + output_dir + " " + email + " " + jobid + " " + animal_name + "&" 

            out = os.system(cmd)
         

            if out != 0:
               return '<BR>Could not request the run.  Please try again.<BR>Error code: %s' % (out)

            else:
               return '<BR>Your request (Assembly of known human sequence id# %s in %s ( %s )) has been successfully submitted.<BR>You will be notified by email when the run is over.<BR><BR>Return to the <a href="./index?email=%s">THOR home page</a>.' % (jobid,animal_clean,latin_clean,email)

            ###################

        else:
            if not sequence:
                # No sequence was specified
                return 'Please enter a DNA sequence <a href="./index?email=%s">here</a>.' % email
            else:
                return 'Please enter a valid email address <a href="./index">here</a>.'
                #return 'Please enter a valid email address <a href="./index?sequence=%s">here</a>.' % sequence ### not trivial to pass the sequence without escaping the character and reapplying the changes --> because of the header and cr characters // other problem with limit on the length of the URI





    assemblyRequest.exposed = True



    #---------------------------------------------
    def readFile(self):

       animal_list = {}
       space_regex = re.compile('\s+')
       leftp_regex = re.compile('\(')
       rightp_regex = re.compile('\)')
 
       file_obj = open(ANIMAL_FILE, 'r')


       for line in file_obj:

          #print "%s" % line
    
          line_regex = re.compile('[\w+\d+\s+]*\,[\w+\d+\s+]*')   ### Will only read lines with comma in them
          line_match = line_regex.match(line)

          if line_match != None:

             cm = line.split(',')                               

             #print "\t^^^%s^^^:^^^%s^^^\n" % (str(cm[0]), str(cm[1]))
             latin = cm[0].strip()                             ### Remove flanking spaces
             common = cm[1].strip()
             #print "\t^^^%s^^^:^^^%s^^^\n" % (latin, common)

             n1 = space_regex.sub('_', common)  #replace space by underscore
             n2 = leftp_regex.sub('_',n1)
             animal_name = rightp_regex.sub('_',n2)
             #print "^^^%s^^^%s^^^%s^^^%s^^^" % (common,n1,n2,animal_name)

         
             fasta = TRACE_ARCHIVE + str(latin) + TRACE_ARCHIVE_FTP + str(latin) + "/fasta/" 
             qual = TRACE_ARCHIVE + str(latin) + TRACE_ARCHIVE_FTP + str(latin) + "/qual/"
  

             if os.path.exists(fasta) and os.path.exists(qual): ### make sure these directories exist

                if not animal_list.has_key(animal_name):
                   animal_list[animal_name]={}

                line_mod = animal_name + ":" + str(latin) + ":" + fasta + ":" + qual

                animal_list[animal_name]['all'] = line_mod 
                animal_list[animal_name]['latin']= str(latin)


       file_obj.close()

       return animal_list


cherrypy.root = WelcomePage()


#def start():

if __name__ == "__main__":

#    cherrypy.root = WelcomePage()
    cherrypy.config.update(file = 'webapp.conf')
#    autoreload.reloadFiles = ["webapp.conf","animal.conf"]
    cherrypy.server.start()


#if __name__ == "__main__":
#    from cherrypy.lib import autoreload
#    autoreload.main(start)
 
